BuildPreReq: /bin/cut, python >= 1.5
%define pyver %(rpm -q python --qf %{VERSION} | cut -d. -f-2)
%define pyfullver %(rpm -q python --qf %{VERSION})

Summary: Python Extension Classes
Name: python-extclass
Version: 1.2
Release: 5
License: BSDish
Group: Development/Languages
Source0: http://www.digicool.com/releases/ExtensionClass/ExtensionClass-%{version}.tar.gz
Source1: ExtensionClass-1.2-note
Patch0: ExtensionClass-1.2-thread.patch
URL: http://www.digicool.com/releases/ExtensionClass
Vendor: Digital Creations
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: python = %{pyfullver}
BuildRequires: python = %{pyfullver}
BuildRequires: python-devel = %{pyfullver}

%package devel
Summary: Python Extension Classes header file
Group: Development/Languages
Requires: %{name} = %{version}
Requires: python = %{pyfullver}

%description
A lightweight mechanism has been developed for making Python extension
types more class-like. Classes can be developed in an extension
language, such as C or C++, and these classes can be treated like
other python classes:
  * They can be sub-classed in python,
  * They provide access to method documentation strings, and
  * They can be used to directly create new instances.

An example class shows how extension classes are implemented and how
they differ from extension types.

Extension classes provide additional extensions to class and instance
semantics, including:
  * A protocol for accessing subobjects "in the context of" their
    containers. This is used to implement custom method types and
    environmental acquisition.
  * A protocol for overriding method call semantics. This is used to
    implement "synchonized" classes and could be used to implement
    argument type checking.
  * A protocol for class initialization that supports execution of a
    special __class_init__ method after a class has been initialized.

Extension classes illustrate how the Python class mechanism can be
extended and may provide a basis for improved or specialized class
models.

%description devel
Python Extension Classes header file

%prep
%setup -n ExtensionClass-%{version}
cp %{SOURCE1} README.1st

%patch0 -p1 -b .thread

%build
ln -s Makefile.pre.in-1.5 Makefile.pre.in
make -f Makefile.pre.in boot
make "OPT=${RPM_OPT_FLAGS}"

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}/python%{pyver}/site-packages
mkdir -p %{buildroot}%{_includedir}/python%{pyver}
install ExtensionClass.h %{buildroot}%{_includedir}/python%{pyver}
%makeinstall

%clean
rm -rf %{buildroot}

%files
%defattr(0644, root, root, 0755)
%doc *.html *.stx *.txt *.notes README*
%attr(0755, root, root) %{_libdir}/python%{pyver}/site-packages/*.so

%files devel
%defattr(0644, root, root, 0755)
%{_includedir}/python%{pyver}/ExtensionClass.h

%changelog
* Fri Feb 27 2004 Peter Soos <sp@osb.hu>
- rebuilt for Fedora Core 1

* Sun Nov 02 2003 Peter Soos <sp@osb.hu>
- rebuilt for RedHat Linux 9
- some spec file tuning

* Tue Oct 05 2001 Peter Soos <sp@osb.hu>
- rebuilt for RedHat Linux 7.2 beta

* Tue Apr 24 2001 Peter Soos <sp@osb.hu>
- rebuilt for RedHat Linux 7.0

* Sun Nov 12 2000 Peter Soos <sp@osb.hu>
- first RPM release
